# keystone.common.cache.core module

Keystone Caching Layer Implementation.

class keystone.common.cache.core.DistributedInvalidationStrategy(region_manager)

  Bases: `RegionInvalidationStrategy`

  invalidate(hard=None)

    Region invalidation.

    `CacheRegion` propagated call. The default invalidation system works by setting a current timestamp (using `time.time()`) to consider all older timestamps effectively invalidated.

  is_hard_invalidated(timestamp)

    Check timestamp to determine if it was hard invalidated.

    Returns:

      Boolean. True if `timestamp` is older than the last region invalidation time and region is invalidated in hard mode.

  is_invalidated(timestamp)

    Check timestamp to determine if it was invalidated.

    Returns:

      Boolean. True if `timestamp` is older than the last region invalidation time.

  is_soft_invalidated(timestamp)

    Check timestamp to determine if it was soft invalidated.

    Returns:

      Boolean. True if `timestamp` is older than the last region invalidation time and region is invalidated in soft mode.

  was_hard_invalidated()

    Indicate the region was invalidated in hard mode.

    Returns:

      Boolean. True if region was invalidated in hard mode.

  was_soft_invalidated()

    Indicate the region was invalidated in soft mode.

    Returns:

      Boolean. True if region was invalidated in soft mode.

class keystone.common.cache.core.RegionInvalidationManager(invalidation_region, region_name)

  Bases: `object`

  REGION_KEY_PREFIX = '<<<region>>>:'
  invalidate_region()
  is_region_key(key)
  property region_id

keystone.common.cache.core.configure_cache(region=None)

keystone.common.cache.core.configure_invalidation_region()

keystone.common.cache.core.create_region(name)

  Create a dopile region.

  Wraps oslo_cache.core.create_region. This is used to ensure that the Region is properly patched and allows us to more easily specify a region name.

  Parameters:

    name (str) – The region name

  Returns:

    The new region.

  Return type:

    `dogpile.cache.region.CacheRegion`

keystone.common.cache.core.get_memoization_decorator(group, expiration_group=None, region=None)

keystone.common.cache.core.key_mangler_factory(invalidation_manager, orig_key_mangler)

this page last updated: 2026-08-17 12:45:24

Except where otherwise noted, this document is licensed under Creative Commons Attribution 3.0 License. See all OpenStack Legal Documents.

found an error? report a bug